//t3216_puzzle_code.h
 
#ifndef HEADER_MAIN_FUNC
  #define HEADER_MAIN_FUNC

  #include "Arduino.h"
  #include "tinyNeoPixel_Static.h" //megaTinyCore version of "Adafruit_NeoPixel.h" library
  #include "clsPCA9555.h"
  #include "Wire.h"
  #include "SimplexNoise.h"

  int freeRam( void );
  float mapf( float x, float in_min, float in_max, float out_min, float out_max ); 

  //Pins  
  #define num_pieces 38
  extern byte pin_state[];
  extern byte pin_state_old[];
  extern byte pieces_placed;

  //Define the two PCA9555D multiplexers
  extern PCA9555 board_0x20; //16 GPIO pins
  extern PCA9555 board_0x21; //16 GPIO pins

  //Simplex Noise
  extern float delta_time;

  //NeoPixels
  #define pin_NEO 0
  #define led_count 217

  // extern Adafruit_NeoPixel strip;
  extern byte pixels[];
  extern tinyNeoPixel strip;

  extern const int x_grid[];
  extern const int y_grid[];
  extern const int z_grid[];
  extern const byte puzzle_id_map[];

  //https://forum.arduino.cc/t/multi-dimensional-arrays-with-different-number-of-elements/557252/2
  #define numElements(x) (sizeof(x) / sizeof(x[0]))

  typedef struct {
      byte *pieces; //NeoPixel IDs
      const byte num_elements; //number of NeoPixels associated
      const byte center_id; //the NeoPixel id associated with the center of the puzzle piece
      const byte pin_index; //which pin number belongs to this puzzle piece
      byte piece_state; //state of the pin/piece
      bool piece_placed; //is the piece just placed
      unsigned long last_debounce_time; //keep track of debouncing
  } pieces;

  extern pieces piece_matrix[];

#endif